//Not shader params, poor man's configuration data for SA. Easier than adding another file for now. This are looked up by SEMANTIC name
int iScreenKey : SCREENKEY = 0x4C;//VK_* for GetAsyncKeyState(), 0x74 is F7, 0x4C is "L" - http://msdn.microsoft.com/en-us/library/windows/desktop/dd375731(v=vs.85).aspx
float fFogRangeFixed = 450.0f;//fixed fog range, 450.0
bool bFixedFog = true;//not used yet

#define SKY_RGB1_6AM_EXTRASUNNYLA 0.337f, 0.337f, 0.337f
#define SKY_RGB2_6AM_EXTRASUNNYLA 0.584f, 0.369f, 0.0f
#define downsampleScale 0.25

/*
#Defines now set by the dll:
SABUILD
*/

#ifdef SABUILD
//Work some game-specific magic
#endif

/*
add bilinear filtering to downsample blit -OR- render with a custom downsample shader and add more blur options

black bars on screen
http://gtaforums.com/topic/194199-documenting-gta-sa-memory-adresses/?view=findpost&p=1057297928
0x53E230 : GUIProc()
0x53EB12 : call GUIProc() (NOP to disable all GUI including crosshairs)
*/

texture2D SceneMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1,1};
	int miplevels = 1;
	string Format = "A8R8G8B8";
	string UIWidget = "None"; >;
	
sampler2D SceneSampler = sampler_state {
	texture = <SceneMap>;
	AddressU  = CLAMP;
	AddressV = CLAMP;
	MipFilter = NONE;
	MinFilter = LINEAR;
	MagFilter = LINEAR; };
	
texture2D DownsampleMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {downsampleScale,downsampleScale};
	int miplevels = 1;
	string Format = "A8R8G8B8";
	string UIWidget = "None"; >;
	
sampler2D DownsampleSampler = sampler_state {
	texture = <DownsampleMap>;
	AddressU  = CLAMP;
	AddressV = CLAMP;
	MipFilter = NONE;
	MinFilter = LINEAR;
	MagFilter = LINEAR; };

float4x4 WorldViewProj : WorldViewProj <string UIWidget = "None";>;

float3 color1 <
string UIWidget = "Color";
string UIName = "RGB 1";
> = {SKY_RGB1_6AM_EXTRASUNNYLA};

float alpha1 <
string UIWidget = "slider";
string UIName = "Alpha 1";
float UIMin = 0.0f;
float UIMax = 1.0f;
float UIStep = 0.01;
> = 1.0f;

float3 color2 <
string UIWidget = "Color";
string UIName = "RGB 2";
> = {SKY_RGB2_6AM_EXTRASUNNYLA};

float alpha2 <
string UIWidget = "slider";
string UIName = "Alpha 2";
float UIMin = 0.0f;
float UIMax = 1.0f;
float UIStep = 0.01;
> = 1.0f;

float lerpAmnt < 
string UIWidget = "slider";
string UIName = "Show Downsample";
float UIMin = 0.0f;
float UIMax = 1.0f;
float UIStep = 0.01;
> = 0.25;

bool correctColor <
string UIName = "Color Correct";
> = true;

//SA-specific vars
#ifdef SABUILD
float4 cc1;//color correct rgb1, alpha1
float4 cc2;//color correct rgb2, alpha2
#endif

float invert(float value) {
float inval = (value - 1) * 2;
return inval;
//return clamp(inval,0,1);
}

struct VS_INPUT {
    float4 Position : POSITION;
    float2 TexCoord : TEXCOORD0;
};

struct VS_OUTPUT {
    float4 Position  : POSITION;
    float2 TexCoord0 : TEXCOORD0;
};

VS_OUTPUT SimpleVS(VS_INPUT IN)
{
    VS_OUTPUT OUT;
	//Half pixel offset corrected in the UV coords in the vertex buffer
    OUT.Position = mul(IN.Position, WorldViewProj);
    OUT.TexCoord0 = IN.TexCoord;
    return OUT;
}

//-------------------------------------------------------------------
// Pixel Shaders
//-------------------------------------------------------------------
float4 PS_Comp_sa(VS_OUTPUT IN) : COLOR
{
	float4 colorScene = tex2D(SceneSampler, IN.TexCoord0);
	float4 colorBlurred = tex2D(DownsampleSampler, IN.TexCoord0);	
	float3 sceneColor = lerp(colorScene.rgb,colorBlurred.rgb,lerpAmnt);
	
	
	
	if(correctColor) {
		float3 color = 0;
		#ifdef SABUILD
			color = sceneColor * (cc1.rgb + cc2.rgb * cc2.a) * 2;
		#else
			color = sceneColor * (color1 + color2 * alpha1) * 2;
		#endif
		
		return float4(color,1); }
	else {
		return colorScene; }
}

//-------------------------------------------------------------------
Technique Simple
{
    Pass P0
    {
        VertexShader = compile vs_2_0 SimpleVS();
        PixelShader = compile ps_2_0 PS_Comp_sa();
		ZEnable = False;
		ZWriteEnable = False;
        CullMode = None;
		AlphaBlendEnable = False;
    }
}
